using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace Jiraiya
{
    public class FridgeDoors : MVRScript
    {
        #region PluginInfo    
        public string pluginAuthor = "Jiraiya";
        public string pluginName = "Chest Lid";
        public string pluginVersion = "1";
        public string pluginDate = "26/08" + "/2021";
        public string pluginDescription = @"Used to open and close the lid on the chest";
        #endregion

        #region Vars    



        public GameObject player;
        public GameObject Ks_Chest;

        protected JSONStorableFloat ScrubA;
	protected JSONStorableFloat yRotation;

        private float previousValue1;
//        private float previousZValue;
//        private float currentZValue;

	private string objectNameSearchString = "Xenoblade Chest";
	public Transform ObjectRoot;
        public Transform topdoor;

        private bool editorInitialized = false;
        private int initLoops = 0;
        private int maxInitLoops = 3600; //3600 for one minute


        private static Atom currentAtom;
        private static string currentAtomName = "None";
        private static string tempAtomName = "None";

        #endregion

        public override void Init()
        {
            try
            {
		if (containingAtom.type != "CustomUnityAsset")
	                {
	                SuperController.LogError("ChestLid - Please add this script on a Custom Unity Asset ( script disabled).");
  	                return;
  		        }

                ScrubA = new JSONStorableFloat("Top Door", 0f, 0f, 3f, true);
                RegisterFloat(ScrubA);
                CreateSlider(ScrubA, false);
                          
              // A tiny bit of help to give some info to your fellow creator and/or player
                JSONStorableString helpText = new JSONStorableString("Help",
                    "<color=#000><size=35><b>Help</b></size></color>\n\n" +
                    "<color=#333>" +
                    "Simple script to allow you to set the Lid position for the chest.\n\n" +
                    "Moving the two slider wil change the open state of the Lid from closed to all the way open.\n\n" +
                    "</color>" );
               UIDynamic helpTextfield = CreateTextField(helpText, true);
                helpTextfield.height = 1100.0f;

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        // Update is called with each rendered frame by Unity
        void Update()
        {
            var Slider1 = ScrubA.val;

           if( initLoops < maxInitLoops && editorInitialized == false ) {
                initLoops++;
                InitEditor();
            }
	if( initLoops == maxInitLoops ) {
                SuperController.LogError("ChestLid : This CUA could not be initialized properly. Please select a compatible object and reload the script.");
                initLoops++; // To avoid spamming the log with the error
            }
         if (previousValue1 != Slider1) OnSliderChanged();
        }

        private bool InitEditor() {
            if( editorInitialized == true ) return true;
        
            ObjectRoot = getObjectRoot( containingAtom.reParentObject );
            if( ObjectRoot == null ) {
                return false;
            }
        
            topdoor = ObjectRoot.Find("Armature/Root/Skl_Root/Cover");
                
            if( topdoor)
		{
                editorInitialized = true;                           
                return true;
            	}
	    else
		{
                SuperController.LogError("ChestLid : your CUA is missing mandatory components.");
                initLoops = maxInitLoops; // We don't have what we need, we consider the initialization failed
                return false;
		}
        
            return false;
        }

     private Transform getObjectRoot( Transform parent ) {
            foreach( Transform child in parent )
            {
                if( child.name.Contains(objectNameSearchString) ) return child;
                else
			{
			Transform childSearch = getObjectRoot(child);
			if (childSearch != null) return childSearch;
                	}
            }
            return null;
        }





        // Top Door
        void OnSliderChanged()
	        {
		var Slider1 = ScrubA.val;
		var a = Slider1 - previousValue1;
		topdoor.transform.Rotate(Vector3.left * a * 56);
		previousValue1 = ScrubA.val;
	        }

   


    }
}